/*
 * Copyright 2002 Slicer/HackersQuest (slicer@hackersquest.org)
 *
 * This file is part of Odin's Eye.
 *
 * Odin's Eye is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Odin's Eye is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */


public class Boot {
  public static void main(String args[]) {
     boolean ok=false;

     try {
       String s=System.getProperty("java.specification.version");
       if (s != null) {
         double ver=Double.valueOf(s).doubleValue();
         if (ver >= 1.4) 
           ok=true;
       }
     } catch (Exception e) {
     }
     if (! ok) {
       System.out.println("=============================================");
       System.out.println("Your java engine must be at least version 1.4");
       System.out.println("=============================================");
       System.out.println("Please go to http://java.sun.com and download");
       System.out.println("a newer version");
       return;
     }

     try {
       ClassLoader cl=new Boot().getClass().getClassLoader();
       Class c=cl.loadClass("MapEditor");
       Class classargs[]=new Class[1];
       classargs[0]=new String[1].getClass();
       Object methargs[]=new Object[1];
       methargs[0]=args;

       java.lang.reflect.Method m=c.getMethod("main", classargs);
       m.invoke(null, methargs);
     } catch (ClassNotFoundException e) {
       System.out.println("Failed to load necesarry classes");
     } catch (NoSuchMethodException e) {
       System.out.println("Main class lacks main() method");
     } catch (IllegalAccessException e) {
       System.out.println("Not allowed to call main()");
     } catch (java.lang.reflect.InvocationTargetException e) {
       System.out.println("main() isn't static");
     }
  }

}
